package esercitazione5.trees;

import java.util.ArrayDeque;
import java.util.Iterator;

public class DinastyTreeVisits {

	public void printTree(DinastyTree t){
		this.printTreeWithTabs(t, 0);
	}
	
	private void printTabs(int tabs){
		for (int i = 0; i < tabs; i++) {
			System.out.print("\t");
		}	
	}
	
	private void printTreeWithTabs(DinastyTree t, Integer level){
		
		if (t != null) {
			
			printTabs(level);
			System.out.println(t.getNome() + " (" + t.getAnni() +")");
			
			for (DinastyTree f : t.getFigli()) {
				printTreeWithTabs(f, level + 1);
			}
		}			
		
	}
	
	public DinastyTree cercaDiscendentePerNome(DinastyTree tree, String nome){
		
		DinastyTree descendantFound = null;
		
		for (int i = 0; (i < tree.getFigli().size()) && (descendantFound==null); i++) {
			
			DinastyTree current = tree.getFigli().get(i);
			if (current.getNome() == nome)
				descendantFound = current;
			else
				descendantFound = this.cercaDiscendentePerNome(current, nome);
		}
		
		return descendantFound;
	}

	

	
public DinastyTree cercaPrimoDiscendenteEtaMinima(DinastyTree tree, Integer anni){

	DinastyTree descendantFound = null;
	
	ArrayDeque<DinastyTree> coda = new ArrayDeque<DinastyTree>();
	
	coda.push(tree);
	
	while (!coda.isEmpty() && descendantFound==null) {
		
		DinastyTree current = coda.pop();
		if (current.getAnni() < anni)
			descendantFound = current;
		else {
			for (DinastyTree f : current.getFigli()) {
				coda.push(f);
			}
		}
	}
	
	return descendantFound;
	
	
}

	
	
}
